#include <stdio.h>

static struct {
	char *name, *keywd;
} cmds[] = {
	{ "right",		"CMD_RIGHT" },
	{ "vpravo",		"CMD_RIGHT" },
	{ "doprava",		"CMD_RIGHT" },
	{ "napravo",		"CMD_RIGHT" },
	{ "left",		"CMD_LEFT" },
	{ "vlevo",		"CMD_LEFT" },
	{ "doleva",		"CMD_LEFT" },
	{ "nalevo",		"CMD_LEFT" },
	{ "step",		"CMD_STEP" },
	{ "go",			"CMD_STEP" },
	{ "move",		"CMD_STEP" },
	{ "forward",		"CMD_STEP" },
	{ "krok",		"CMD_STEP" },
	{ "jdi",		"CMD_STEP" },
	{ "vpred",		"CMD_STEP" },
	{ "dopredu",		"CMD_STEP" },
	{ "posun",		"CMD_STEP" },
	{ "iswall",		"CMD_IS_WALL" },
	{ "jezed",		"CMD_IS_WALL" },
	{ "isnotwall",		"CMD_IS_NOT_WALL" },
	{ "nenized",		"CMD_IS_NOT_WALL" },
	{ "ishome",		"CMD_IS_HOME" },
	{ "jestart",		"CMD_IS_HOME" },
	{ "isnothome",		"CMD_IS_NOT_HOME" },
	{ "nenistart",		"CMD_IS_NOT_HOME" },
	{ "restart",		"CMD_RESTART" },
	{ "znovu",		"CMD_RESTART" },
	{ "end",		"CMD_END" },
	{ "konec",		"CMD_END" },
};

#define H 64
int ht[H];
unsigned hh[H];
int shift[H];

int main(void)
{
	int n = sizeof(cmds) / sizeof(cmds[0]);
	for (int i=0; i<H; i++)
		ht[i] = -1;
	for (int i=0; i<n; i++) {
		char *c = cmds[i].name;
		unsigned int h = 0;
		while (*c) {
			h = h*23 + *c++;
		}
		unsigned j = h % H;
		int lim = H;
		int sh = 0;
		while (ht[j] >= 0) {
			sh++;
			if (!--lim) {
				fprintf(stderr, "overflow!\n");
				return 1;
			}
			if (hh[j] == h) {
				fprintf(stderr, "collision!\n");
				return 1;
			}
			j = (j+1) % H;
		}
		ht[j] = i;
		hh[j] = h;
		shift[j] = sh;
	}

	printf("#define HASH_SIZE %d\n", H);
	for (int i=0; i<H; i++)
		if (ht[i] < 0) {
			printf("{ 0x00000000, -1, },\n");
		} else {
			printf("{ 0x%08x, %-16s },   // %s (+%d)\n", hh[i], cmds[ht[i]].keywd, cmds[ht[i]].name, shift[i]);
		}

	return 0;
}
